%global debug_package   %{nil}
%global provider        github
%global provider_tld    com
%global project         sensu
%global repo            uchiwa
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          0.8.1
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global networking      0

Name:           %{repo}
Version:        %{commit}
Release:        5%{?dist}
Summary:        Uchiwa is a simple dashboard for the Sensu monitoring framework, built with Go and AngularJS.
License:        MIT
URL:            https://%{import_path}
Source0:        https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Source1:        uchiwa.service
# Generated by
# git clone https://github.com/sensu/uchiwa-web
# git checkout 0.8.1
# npm install bower
# ./node_modules/bower/bin/bower install
# tar -czf uchiwa_bower_components-%{version}.tar.gz bower_components
Source2:        uchiwa_bower_components-%{version}.tar.gz
Source3:        https://github.com/sensu/uchiwa-web/archive/%{commit}/uchiwa-web-%{shortcommit}.tar.gz
BuildRequires:  systemd
BuildRequires:  golang(github.com/bencaron/gosensu)
BuildRequires:  golang(github.com/goji/httpauth)
BuildRequires:  golang(github.com/palourde/logger)
BuildRequires:  golang(github.com/stretchr/testify)
BuildRequires:  golang(github.com/dgrijalva/jwt-go)
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
%{summary}

%prep
%setup -q -n %{repo}-%{commit}
rm -rf Godeps

%build
# set up temporary build gopath, and put our directory there
mkdir -p ./_build/src/github.com/sensu
ln -s $(pwd) ./_build/src/github.com/sensu/uchiwa

export GOPATH=$(pwd)/_build:%{gopath}
go build .

%install
mkdir -p %{buildroot}%{_bindir}
install uchiwa-%{version} %{buildroot}%{_bindir}/uchiwa

mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
cp config.json.example %{buildroot}%{_sysconfdir}/%{name}/uchiwa.json

install -d -p %{buildroot}/%{_datadir}/%{name}
cp -rpav public %{buildroot}/%{_datadir}/%{name}
tar -xzf %{SOURCE2} -C %{buildroot}/%{_datadir}/%{name}/public
tar -xzf %{SOURCE3} -C %{buildroot}/%{_datadir}/%{name}/public/bower_components uchiwa-web-%{version}/css uchiwa-web-%{version}/fonts uchiwa-web-%{version}/img uchiwa-web-%{version}/js uchiwa-web-%{version}/favicon.ico uchiwa-web-%{version}/partials
mv %{buildroot}/%{_datadir}/%{name}/public/bower_components/uchiwa-web-%{version} %{buildroot}/%{_datadir}/%{name}/public/bower_components/uchiwa-web

%check
%if 0%{networking} > 0
export GOPATH=$(pwd)/_build:%{gopath}
go test ./uchiwa
%endif

%files
%defattr(-, uchiwa, uchiwa, -)
%doc CHANGELOG.md README.md LICENSE
%attr(0755, root, root) %{_bindir}/uchiwa
%{_unitdir}/uchiwa.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.json
%{_datadir}/%{name}

%pre
getent group uchiwa >/dev/null || groupadd -r uchiwa
getent passwd uchiwa >/dev/null || \
    useradd -r -g uchiwa -d /etc/uchiwa -s /sbin/nologin \
    -c "Uchiwa Sensu Web Interface" uchiwa
exit 0

%post
%systemd_post uchiwa.service
%preun
%systemd_preun uchiwa.service

%postun
%systemd_postun uchiwa.service

%changelog
* Fri Jul 22 2016 Lon Hohberger <lon@redhat.com> - 0.8.0-5
- Rebuild for golang 1.6.3

* Fri Jul 22 2016 Lon Hohberger <lon@redhat.com> - 0.8.0-3
- Rebuild for newer golang 1.6.2

* Tue Jul 28 2015 Lon Hohberger <lon@redhat.com> - 0.8.0-2
- Fix permissions on /usr/bin/uchiwa

* Tue May 05 2015 Graeme Gillies <ggillies@redhat.com> - 0.8.0-1
- Update to version 0.8.0

* Mon Feb 02 2015 Graeme Gillies <ggillies@redhat.com> - 0.4.1-1
- First package for Fedora


